#!/bin/sh
#########################################################################################
#check_backuplog.sh
#by A. Laub andreas@laub-home.de
#this Script reads a Backup Logfile which contains one line in this format:
#	201005131629 ERROR: Backup has Problems
#   or
# 	201005131629 SUCCESS: Backup runs well 
#date Format is: date +%Y%m%d%H%M
#
#run script:
#	check_backuplog.sh [LOGFILE] [TIME]
#
#License:
#This program is free software: you can redistribute it and/or modify it
#under the terms of the GNU General Public License as published by the 
#Free Software Foundation, either version 3 of the License, or (at your option) 
#any later version.
#This program is distributed in the hope that it will be useful, 
#but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
#or FITNESS FOR A PARTICULAR PURPOSE. 
########################################################################################

#Load the Pathes
PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
export PATH

#set the variables
#This could be $1 or an hardcoded Logfilepath
LOGFILE="$1"
#Time in hours to get a critical error
TIME="$2"
#Time in hours to get a Warning when script is still running
RUNNINGTIME="$3"

# Don't edit this
if [ "`grep "RUNNING" $LOGFILE`" ]; then
	if [ "`cat $LOGFILE | awk '{print $1}' `" -le "`date -d '-'$RUNNINGTIME' hours' +%Y%m%d%H%M`" ]; then
		echo "WARNING - `cat $LOGFILE`"
		exit 1
	else 
		echo "OK - `cat $LOGFILE`"
		exit 0
	fi
fi 
if [ ! -f $LOGFILE ]; then
	echo "CRITICAL - Logfile doesn't exist"
	exit 2
fi
if [ "`cat $LOGFILE | awk '{print $1}' `" -le "`date -d '-'$TIME' hours' +%Y%m%d%H%M`" ]; then
	echo "CRITICAL - Backup didn't start within the last $TIME hours"
	exit 2
fi
if [ "`grep "ERROR" $LOGFILE`" ]; then
	echo "CRITICAL - `cat $LOGFILE`"
	exit 2
fi 
if [ "`grep "SUCCESS" $LOGFILE`" ]; then
	RUNTIME=$(awk -F": " '{print $3}' $LOGFILE)
	echo "OK - Backup runs well! Runtime: $RUNTIME | runtime=$RUNTIME"
	exit 0
fi
echo "CRITICAL - other Error"
exit 2
